#ifndef __MAGIC_H__
#define __MAGIC_H__


/* ------------
 * DECLARATIONS
 * ------------ */

/* GEMS specific */
inline void simicsBreakpoint();

/* for footprint info gathering */
inline void newFootprint();
inline void getFootprintL1(int * hitCount, int * missCount, int * voidCount, int * restCount) ;
inline void getFootprintL2(int * hitCount, int * missCount, int * voidCount, int * restCount) ;

/* for sanity checking */
inline void getTotalMemoryAccesses(int * accesses);
inline void getTotalMemoryAccessesForwardedToL2(int * accesses);


/* -----------
 * DEFINITIONS
 * ----------- */

#define GEMS_MAGIC_CALL(service)                       \
  __asm__ __volatile__                                 \
    ( "sethi %1, %%g0  !magic service %2\n\t"          \
      : /* no outputs */                               \
      : "r" (0), "i" (service), "i" (service)          \
      : "l0", "memory" /* clobber register */          \
    );                                                        

#define GET_G2(pointer)      \
  __asm__ __volatile__       \
    ( "mov %%g2, %0 \n\t"    \
      : "=r" (*pointer)      \
    );                              

#define GET_G3(pointer)      \
  __asm__ __volatile__       \
    ( "mov %%g3, %0 \n\t"    \
      : "=r" (*pointer)      \
    );                                                        

inline void simicsBreakpoint()
{
    GEMS_MAGIC_CALL(0x40000);
    GEMS_MAGIC_CALL(497);
}

inline void newFootprint()
{
    GEMS_MAGIC_CALL(499);
}

inline void getFootprintL1(int * hitCount, int * missCount, int * voidCount, int * restCount) 
{
    GEMS_MAGIC_CALL(501);
    GET_G2(hitCount);
    GET_G3(missCount);

    GEMS_MAGIC_CALL(502);
    GET_G2(voidCount);
    GET_G3(restCount);
}

inline void getFootprintL2(int * hitCount, int * missCount, int * voidCount, int * restCount) 
{
    GEMS_MAGIC_CALL(503);
    GET_G2(hitCount);
    GET_G3(missCount);

    GEMS_MAGIC_CALL(504);
    GET_G2(voidCount);
    GET_G3(restCount);
}

inline void getTotalMemoryAccesses(int * accesses)
{
    GEMS_MAGIC_CALL(505);
    GET_G2(accesses);
}

inline void getTotalMemoryAccessesForwardedToL2(int * accesses)
{
    GEMS_MAGIC_CALL(506);
    GET_G2(accesses);
}

#endif /* __MAGIC_H__ */

